
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Learning_pathsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const learning_paths = await db.learning_paths.create(
            {
                id: data.id || undefined,
        
        path_name: data.path_name
        ||
        null
            ,
            
        audience: data.audience
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await learning_paths.setProgram( data.program || null, {
            transaction,
        });
        
        await learning_paths.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return learning_paths;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const learning_pathsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                path_name: item.path_name
            ||
            null
            ,
            
                audience: item.audience
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const learning_paths = await db.learning_paths.bulkCreate(learning_pathsData, { transaction });

        // For each item created, replace relation files
        

        return learning_paths;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const learning_paths = await db.learning_paths.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.path_name !== undefined) updatePayload.path_name = data.path_name;
        
        
        if (data.audience !== undefined) updatePayload.audience = data.audience;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await learning_paths.update(updatePayload, {transaction});

        
        
        if (data.program !== undefined) {
            await learning_paths.setProgram(
              
              data.program,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await learning_paths.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return learning_paths;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const learning_paths = await db.learning_paths.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of learning_paths) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of learning_paths) {
                await record.destroy({transaction});
            }
        });


        return learning_paths;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const learning_paths = await db.learning_paths.findByPk(id, options);

        await learning_paths.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await learning_paths.destroy({
            transaction
        });

        return learning_paths;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const learning_paths = await db.learning_paths.findOne(
            { where },
            { transaction },
        );

        if (!learning_paths) {
            return learning_paths;
        }

        const output = learning_paths.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        output.missions_learning_path = await learning_paths.getMissions_learning_path({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.program = await learning_paths.getProgram({
            transaction
        });
        
        
        output.organizations = await learning_paths.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.programs,
        as: 'program',
        
        where: filter.program ? {
          [Op.or]: [
            { id: { [Op.in]: filter.program.split('|').map(term => Utils.uuid(term)) } },
            {
              program_name: {
                [Op.or]: filter.program.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.path_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'learning_paths',
                        'path_name',
                        filter.path_name,
                    ),
                };
            }
            
            if (filter.audience) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'learning_paths',
                        'audience',
                        filter.audience,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'learning_paths',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.learning_paths.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'learning_paths',
                        'path_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.learning_paths.findAll({
            attributes: [ 'id', 'path_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['path_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.path_name,
        }));
    }

    
};

